# Bird base class
#
class Bird:
    #Initialize Bird class data attributes
    def __init__(self, sex):
        self.__feathers = 'yes'     #Birds have feathers
        self.__bones = 'hollow'     #Bird bones are hollow
        self.__eggs = 'hard-shell'  #Bird eggs are hard-shell.
        self.__sex = sex            #Male, female, or unknown.

    #Mutator methods for Bird data attributes
    def set_sex(self, sex):    #Male, female, or unknown.
        self.__sex = sex

    #Accessor methods for Bird data attributes
    def get_feathers(self):
        return self.__feathers

    def get_bones(self):
        return self.__bones

    def get_eggs(self):
        return self.__eggs

    def get_sex(self):
        return self.__sex


#
# Barn Swallow subclass (base class: Bird)
#
class BarnSwallow(Bird):
    
    #Initialize Barn Swallow data attributes & obtain Bird inheritance.
    def __init__(self, sex, flock_size):
        
        #Obtain base class data attributes & methods (inheritance)
        Bird.__init__(self, sex)

        #Initialize subclass data atttributes
        self.__migratory = 'yes'        #Migratory bird.
        self.__flock_size = flock_size  #How many in flock.
        
        
    #Mutator methods for Barn Swallow data attributes
    def set_flock_size(self,flock_size):  #No. of birds in sighting
        self.__flock_size = flock_size

    #Accessor methods for Barn Swallow data attributes
    def get_migratory(self):
        return self.__migratory
    def get_flock_size(self):
        return self.__flock_size

#
# South Africa Cliff Swallow subclass (base class: Bird)
#
class SouthAfricaCliffSwallow(Bird):
    
    #Initialize Cliff Swallow data attributes & obtain Bird inheritance.
    def __init__(self, sex, flock_size):
        
        #Obtain base class data attributes & methods (inheritance)
        Bird.__init__(self, sex)

        #Initialize subclass data atttributes
        self.__migratory = 'no'         #Non-migratory bird.
        self.__flock_size = flock_size  #How many in flock.
        
        
    #Mutator methods for Cliff Swallow data attributes
    def set_flock_size(self,flock_size):  #No. of birds in sighting
        self.__flock_size = flock_size

    #Accessor methods for Cliff Swallow data attributes
    def get_migratory(self):
        return self.__migratory
    def get_flock_size(self):
        return self.__flock_size


