#!/usr/bin/python3
from tkinter import *

class Application(Frame):
    """Build the basic window frame template"""

    def __init__(self, master):
        super(Application, self).__init__(master)
        self.grid()
        self.create_widgets()

    def create_widgets(self):
        self.label1 = Label(self, text='Please enter some text in lower case')
        self.label1.grid(row=0)

        self.text1 = Entry(self)
        self.text1.grid(row=2)

        self.button1 = Button(self, text="Convert text", command=self.convert)
        self.button1.grid(row=6, column=0)
        self.button2 = Button(self, text='Clear result', command=self.clear)
        self.button2.grid(row=6, column=1)
        self.text1.focus_set()

    def convert(self):
        """Retrieve the text and convert to upper case"""
        varText = self.text1.get()
        varReplaced = varText.upper()
        self.text1.delete(0, END)
        self.text1.insert(END, varReplaced)


    def clear(self):
        """Clear the Entry forms"""
        self.text1.delete(0,END)
        self.text1.focus_set()


root = Tk()
root.title('Testing and Entry widget')
root.geometry('500x200')
app = Application(root)
app.mainloop()
