#script2304.py - Play Music from List Randomly
#Written by Blum and Bresnahan
# 
##############################################
#
##### Import Functions & Variables #######
#
from os import system		#Import from OS module
#
				#Import from PyGame Library
from pygame import display, event, init, mixer, time
#
from random import randint	#Import from Random module
#
from sys import exit		#Import from System module
#
from pygame.locals import *	#Load PyGame constants
#
init()				#Initialize PyGame
#
# Load Music Play List Function ##################
#
# Read Playlist and Queue up Songs #
#
def Load_Music ():
#
	global SongList		#Make SongList global
	SongList = []		#Initialize SongList to Null
	#
	global SongNumber	#Make SongNumber global
	SongNumber = 0		#Intialize Song Number to 0
	#
	global MaxSongs		#Make MaxSongs global
	MaxSongs = 0		#Intialize Maximum Songs to 0
	#
	PlayList = MusicDirectory + '/' + 'playlist.txt'
	PlayList = open(PlayList, 'r')
	#
	for Song in PlayList:	#Load PlayList into SongList
	#
		Song = Song.rstrip('\n') #Strip off newline
		if Song != "":   #Avoid blank lines in PlayList
			Song = MusicDirectory + '/' + Song
			SongList.append(Song)
			MaxSongs = MaxSongs + 1
	PlayList.close()
#
# Play The Music Function #########################
#
def Play_Music (SongList,SongNumber):
	mixer.music.load(SongList[SongNumber])
	mixer.music.play(0)
	mixer.music.set_endevent(USEREVENT)	#Send event when Music Stops
#
# Gracefully Exit Script Function #################
#
def Graceful_Exit ():
	mixer.music.stop() #Stop any music.
	mixer.quit()	   #Quit mixer
	time.delay(3000)   #Allow things to shutdown
	Command = "sudo umount " + MusicDisk
	system(Command)    #Unmount disk
	exit()
#
# Set up Music Variables ######################
# 
MusicDirectory = '/home/pi/music'
MusicDisk = '/dev/sda1'
#
# Mount the Music Drive ########################
#
Command = "sudo umount " + MusicDisk + " 2>/dev/null"
system(Command)
Command = "sudo mount -t vfat " + MusicDisk + " " + MusicDirectory
system(Command)
#
# Queue up the Music #############################
#
Load_Music()
Play_Music(SongList,SongNumber)
SongNumber = SongNumber + 1
#
#Set up Display for Event Handling ##############
#
MusicScreen = display.set_mode((0,0))
display.set_caption("Playing Music...")
#
while True:  #Keep playing the Music ############
	for Event in event.get():
	#
		if Event.type == USEREVENT:
			if SongNumber < MaxSongs: #Play through list 1x
				Play_Music(SongList,SongNumber)
				SongNumber = SongNumber + 1
			if SongNumber >= MaxSongs: 
				SongNumber = randint(0,MaxSongs - 1) #Pick random song
				Play_Music(SongList,SongNumber)
				SongNumber = MaxSongs #Keep songs random
				#
		if Event.type in (QUIT,KEYDOWN,MOUSEBUTTONDOWN):
			Graceful_Exit()
#



