#script2305.py - Special HD Presentation with Sound
#Written by Blum and Bresnahan
# 
##########################################
#
##### Import Functions & Variables #######
#
from os import listdir, system	#Import from OS module
#
				#Import from PyGame Library
from pygame import event, font, display, image, init, mixer, time, transform
#
from random import randint	#Import from Random module
#
from sys import exit		#Import from System module
#
from pygame.locals import *	#Load PyGame constants
#
init()				#Initialize PyGame
#
# Load Music Play List Function ##################
#
# Read Playlist and Queue up Songs #
#
def Load_Music ():
#
	global SongList		#Make SongList global
	SongList = []		#Initialize SongList to Null
	#
	global SongNumber	#Make SongNumber global
	SongNumber = 0		#Intialize Song Number to 0
	#
	global MaxSongs		#Make MaxSongs global
	MaxSongs = 0		#Intialize Maximum Songs to 0
	#
	PlayList = PictureDirectory + '/' + 'playlist.txt'
	PlayList = open(PlayList, 'r')
	#
	for Song in PlayList:	#Load PlayList into SongList
	#
		Song = Song.rstrip('\n') #Strip off newline
		if Song != "":   #Avoid blank lines in PlayList
			Song = PictureDirectory + '/' + Song
			SongList.append(Song)
			MaxSongs = MaxSongs + 1
	PlayList.close()
#
# Play The Music Function #########################
#
def Play_Music (SongList,SongNumber):
	mixer.music.load(SongList[SongNumber])
	mixer.music.play(0)
	mixer.music.set_endevent(USEREVENT)	#Send event when Music Stops
#
# Gracefully Exit Script Function #################
#
def Graceful_Exit ():
	mixer.music.stop() #Stop any music.
	mixer.quit()	   #Quit mixer
	time.delay(3000)   #Allow things to shutdown
	Command = "sudo umount " + PictureDisk
	system(Command)    #Unmount disk
	exit()
#
# Set up Picture Variables ######################
# 
PictureDirectory = '/home/pi/pictures'
PictureFileExtension = '.jpg'
PictureDisk = '/dev/sda1'
#
# Mount the Picture Drive ########################
#
Command = "sudo umount " + PictureDisk + " 2>/dev/null"
system(Command)
Command = "sudo mount -t vfat " + PictureDisk + " " + PictureDirectory
system(Command)
#
# Set up Presentation Text #######################
#
# Color #
#
RazPiRed = 210,40,82
#
# Font #
#
DefaultFont='/usr/share/fonts/truetype/freefont/FreeSans.ttf'
PrezFont=font.Font(DefaultFont,60)
#
# Text #
#
IntroText1="Why Our School Should"
IntroText2="Use Raspberry Pi's and Teach Python"
IntroText1=PrezFont.render(IntroText1,True,RazPiRed)
IntroText2=PrezFont.render(IntroText2,True,RazPiRed)
#
# Set up the Presentation Screen ################
#
ScreenColor = Gray = 125,125,125
#
ScreenFlag = FULLSCREEN | NOFRAME | DOUBLEBUF
PrezScreen = display.set_mode((0,0),ScreenFlag)
#
PrezScreenRect = PrezScreen.get_rect()
CenterScreen = PrezScreenRect.center
AboveCenterScreen = CenterScreen[0],CenterScreen[1]-100
#
PrezScreenSize = PrezScreen.get_size()
Scale=PrezScreenSize[0]-20,PrezScreenSize[1]-20
#
###### Run the Presentation  #######################################
#
# Queue up the Music ##############################
#
Load_Music()
Play_Music(SongList,SongNumber)
SongNumber = SongNumber + 1
#
while True:
	# Introduction Screen ##############################
	#
	PrezScreen.fill(ScreenColor)
	#
	# Put Intro Text Line 1 above Center of Screen
	IntroText1Location = IntroText1.get_rect()
	IntroText1Location.center = AboveCenterScreen
	PrezScreen.blit(IntroText1,IntroText1Location)
	#
	# Put Intro Text Line 2 at Center of Screen
	IntroText2Location = IntroText2.get_rect()
	IntroText2Location.center = CenterScreen
	PrezScreen.blit(IntroText2,IntroText2Location)
	#
	display.update()
	#
	#Get HD Pictures ###################################
	#
	for Picture in listdir(PictureDirectory):
		if Picture.endswith(PictureFileExtension):
			Picture = PictureDirectory + '/' + Picture
			#
			Picture = image.load(Picture)
			#
			for Event in event.get():
				#
				if Event.type == USEREVENT:
					if SongNumber < MaxSongs:
						Play_Music(SongList,SongNumber)
						SongNumber = SongNumber + 1
					if SongNumber >= MaxSongs:
						SongNumber = randint(0,MaxSongs - 1) #Pick random song
						Play_Music(SongList,SongNumber)
						SongNumber = MaxSongs #Keep it random
				#
				if Event.type in (QUIT,KEYDOWN):
					Graceful_Exit()
			#
			# If Picture is bigger than screen, scale it down.
			if Picture.get_size() > PrezScreenSize:
				Picture = transform.scale(Picture,Scale)
			#
			PictureLocation=Picture.get_rect()  #Current location 
			PictureLocation.center=CenterScreen #Put picture in center of screen
			#
			#Display HD Images to Screen #################3
			PrezScreen.fill(ScreenColor)
			PrezScreen.blit(Picture,PictureLocation)
			display.update()
		#
		# Quit with Keyboard if Desired
		for Event in event.get():
			if Event.type in (QUIT,KEYDOWN):
				Graceful_Exit()
#



