# Sightings base class
#
class Sighting:
    #Initialize Sighting class data attributes
    def __init__(self, sight_location, sight_date):
        self.__sight_location = sight_location  #Location of sighting
        self.__sight_date = sight_date          #Date of sighting

    #Mutator methods for Sighting data attributes
    def set_sight_location(self, sight_location):
        self.__sight_location = sight_location

    def set_sight_date(self, sight_date):
        self.__sight_date = sight_date

    #Accessor methods for Sighting data attributes
    def get_sight_location(self):
        return self.__sight_location

    def get_sight_date(self):
        return self.__sight_date
#
# Bird Sighting subclass (base class: Sighting)
#
class BirdSighting(Sighting):
    
    #Initialize Bird Sighting data attributes & obtain Bird inheritance.
    def __init__(self, sight_location, sight_date,
                 bird_species, flock_size):
        
        #Obtain base class data attributes & methods (inheritance)
        Sighting.__init__(self, sight_location, sight_date)

        #Initialize subclass data atttributes
        self.__bird_species = bird_species #Bird type
        self.__flock_size = flock_size     #How many in flock.
        
        
    #Mutator methods for Bird Sighting data attributes
    def set_bird_species(self,bird_species):
        self.__bird_species = bird_species

    def set_flock_size(self,flock_size):
        self.__flock_size = flock_size

    #Accessor methods for Bird Sighting data attributes
    def get_bird_species(self):
        return self.__bird_species
    def get_flock_size(self):
        return self.__flock_size
